#include <iostream>
#include <fstream>
#include "common.h"
using namespace std;

static bool run(istream& data_in, ostream& data_out)
{
	zadanie z;
	rozwiazanie r;
	int in_form = 0;

	data_in >> in_form;
	if (!data_in || in_form < 1 || in_form > 2) {
		cerr << "ERR: nieobsługiwana wersja formatu danych wejsciowych\n";
		return false;
	}

	if (in_form == 1 && !read_data_form1(z, data_in))
		return false;
	if (in_form == 2 && !read_data_form2(z, data_in))
		return false;

	if (!solve(z, r))
		return false;

	if (!write_data(z, r, data_out))
		return false;

	return true;
}

int main(int argc, char **argv)
{
	istream *p_in = &cin;
	ostream *p_out = &cout;

	if (argc > 1)
		p_in = new ifstream(argv[1]);
	if (argc > 2)
		p_out = new ofstream(argv[2]);

	bool r = run(*p_in, *p_out);

	if (argc > 2)
		delete p_out;
	if (argc > 1)
		delete p_in;

	return !r;
}
